#include <stdio.h>
#include <System.h>

using System::Exceptions::Exception;
using namespace System::Exceptions::Std;

System::VStruct *foo;

int main()
{
	Exception *e, *e2;
	SystemException *se, *se2;
	
	MemoryFault mf;
	InstrFault inf;
	ArchInstrFault aif;
	
	// Upcasts can be done directly.
	se = &mf;
	
	// Downcast not needed, but should work anyway
	e = Exception::downcast(&inf);
	
	MemoryFault *mf2 = MemoryFault::downcast(se),
	            *mf3 = MemoryFault::downcast(e);
	InstrFault *inf2 = InstrFault::downcast(se),
	           *inf3 = InstrFault::downcast(e);
	OutOfMemory *oom = OutOfMemory::downcast(e),
	            *oom2 = OutOfMemory::downcast(&aif);
	
	e2 = Exception::downcast(&aif);
	se2 = SystemException::downcast(foo);
	
	printf("Exception: %p %p (should be: ptr NULL)\n", e, e2);
	printf("SystemException: %p %p (should be: ptr NULL)\n", se, se2);
	printf("MemoryFault: %p %p (should be: ptr NULL)\n", mf2, mf3);
	printf("InstrFault: %p %p (should be: NULL ptr)\n", inf2, inf3);
	printf("OutOfMemory: %p %p (should be: NULL NULL)\n", oom, oom2);
		
	return 0;
}
