#ifndef _UTIL_MISC_H
#define _UTIL_MISC_H

namespace Util {
	// Round the given value up or down to the specified power-of-two.

	template<typename T>
	static inline T round_up(T val, int shift)
	{
		return (val + (1UL << shift) - 1) & ~((1UL << shift) - 1);
	}

	template<typename T>
	static inline T round_down(T val, int shift)
	{
		return val & ~((1UL << shift) - 1);
	}
}

#endif
