#include <util/rbtree.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

using Util::RBTree;

struct Data;
//struct Node;
typedef RBTree<Data, unsigned int, unsigned int> RBType;

#if 0
struct Node {
	unsigned int data;

	bool operator < (Node &d)
	{
		return data < d.data;
	}

	bool operator < (int d)
	{
		return data < d;
	}

	bool operator > (int d)
	{
		return data > d;
	}
};

#endif
struct Data {
	unsigned int magic;
	RBType::Node rbtree_node;
	
	Data()
	{
		magic = 0xdeadbeef;
	}
};

static const unsigned int rbtree_size = 1000000;

Data data[rbtree_size];

int main(void)
{
	RBType rbtree;
	srandom(time(NULL));
	
	for (unsigned int i = 0; i < rbtree_size; i++) {
		Data *d = &data[i];
		unsigned int val;

		do {
			val = random() & 0x7fffffff;
		} while (rbtree.find(val));
		
		d->rbtree_node.value = val;
		rbtree.add(d);
	}

	for (unsigned int i = 0; i < rbtree_size; i++) {
		unsigned int val = data[i].rbtree_node.value;
		Data *d = rbtree.find(val);
		assert(d);
		assert(d->rbtree_node.value == val);
		rbtree.del(d);
	}

	printf("PASSED\n");
}
