#ifndef _ARCH_THREAD_H
#define _ARCH_THREAD_H

#include <kern/types.h>

namespace Threads {
	class Thread;
}

namespace Arch {
	struct ArchThread {
		void *rsp, *rbp;
		u8 jump_to_init;
		
		enum {
			size = 4096
		};
		
		void init(void *entry, void *arg);
	};

	void switch_thread(Threads::Thread *dest, Threads::Thread *src);
	
	namespace Priv {
		struct TSS {
			u32 padding;
			u32 reserved1;
			u64 rsp[3];
			u64 reserved2;
			u64 ist[7];
			u16 reserved3[5];
			u16 iomap_base;
		};
		
		extern TSS tss;
	}
};

#endif
